/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once


#define EQUIPMENT


#define INI_FILE "./UFOExtender.ini"
#define INI_READ_INT(section,key,default) GetPrivateProfileIntA(section,key,default,INI_FILE)
#define INI_READ_STRING(section,key,default,buf,size) GetPrivateProfileStringA(section,key,default,buf,size,INI_FILE)

#define EXPORT_ONCE __declspec(selectany)
// Data imported from the original executable

typedef struct  
{
  unsigned char Unit_Type;				//0
  char Paper_Doll;
  char Unknown1;
  char Unknown2;
  char Unknown3;
  char Unknown4;
  char Unknown5;
  char Unknown6;
  char Unknown7;
  char Unknown8;
  char Facing;					//10
  char MovementType;
  unsigned char TUs_Current;
  char HPs_Current;
  char Stun;
  char EUs_Current;
  char React_Current;
  char Strength;
  char F_Armor_Current;
  char L_Armor_Current;
  char R_Armor_Current;			//20
  char B_Armor_Current;
  char U_Armor_Current;
  char Firing_Acc;
  char Throw_Acc;
  unsigned char TUs_Max;
  char HPs_Max;
  char EUs_Max;
  char React_Max;
  char F_Armor_Max;
  char L_Armor_Max;				//30
  char R_Armor_Max;
  char B_Armor_Max;
  char U_Armor_Max;
  char UnknownA;
  char EU_Recharge;
  char UnknownB;
  char Psi_Skill;
  char obdata_index;
  char VPs;
  unsigned char soldier_index;			//40
  char UnknownC;
  char Rank;
  char UnknownD;
  char Aggression;
  char EU_Usage;
  char HWP_Turret;
  char UnknownE;
  char UnknownF;
  char Stand_Height;
  char Crouch_Height;			//50
  char UnknownG;
  char UnknownH;
  char L_Hand_Item;
  char R_Hand_Item;
  char UnknownI;
  char Close_Acc;
  char Psi_Strength;
  char Morale;
  char Bravery;
  char UnknownJ;				//60
  char UnknownK;
  char Scanner_Blip;
  char Head_Fatal;
  char Torso_Fatal;
  char R_Arm_Fatal;
  char L_Arm_Fatal;
  char R_Leg_Fatal;
  char L_Leg_Fatal;
  char UnknownL;
  char UnknownM;				//70
  char UnknownN;
  char UnknownO;
  char Intelligence;
  char UnknownP;
  char UnknownQ;
  char Mission_Count;
  char UnknownR;
  short Kills;
  char React_Count;				//80
  char Shot_Count;
  char Rod_Count;
  char Throw_Count;
  char Psi_Count;
  char Panic_Count;				//85
  char Name[26];
  char UnknownS;
  char Inventory_Access;
  char On_Fire;
  char Gender;
  char Race;
  char Turret_Weapon;
  char Turret_Ammo;
  char Unknown;
  char Bitflags;
  char UnknownT;
  char UnknownU;
  char UnknownV;
}
unitref_dat;

typedef struct
{
	unsigned char itemType;
	unsigned char ypos;
	unsigned char xpos;
	unsigned char zpos;
	unsigned char owner;
	unsigned char slot;
	unsigned short container;
	unsigned char quantity1;
	unsigned char quantity2;
	unsigned char quantity3;
	unsigned char height_offset;
	unsigned int flags;
}
obpos_dat;


EXPORT_ONCE int (*GetUnitEncumberance)(int)=(int (__cdecl *)(int))0x413820;
EXPORT_ONCE void (*DrawNumber)(int number, int color, int dst, __int16 useSmallFont)=(void (__cdecl *)(int,int,int,short))0x450A10;
EXPORT_ONCE void (*DrawNumber2)(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)=(void (__cdecl *)(int,int,__int16,__int16,int))0x450B00;



EXPORT_ONCE void (*DrawSmallLetter)(int chr, int col, int dst)=(void (__cdecl *)(int,int,int))0x450660;
EXPORT_ONCE void (*DrawString)(const char *str, int color, __int16 ypos, __int16 xpos, int smallFont)=(void (__cdecl *)(const char *str, int color, __int16 ypos, __int16 xpos, int smallFont))0x4501A0;
EXPORT_ONCE int (*UpdateRadarStats)(int base)=(int (__cdecl *)(int))0x439D10;
EXPORT_ONCE int (*GetRandom_0_n)(int n)=(int (__cdecl *)(int))0x43D850;

EXPORT_ONCE int (*LoadFile)(void *dstbuf, int filename)=(int (__cdecl *)(void *,int))0x43B5A0;
EXPORT_ONCE int (*AlienTakeActionAfterShootDown)(void *pUFOCraft, void * pAttackingCraft)=(int (__cdecl *)(void *,void *))0x432A80;
                            
EXPORT_ONCE int (*GetClickedButton)()=(int (__cdecl *)())0x450F10;
EXPORT_ONCE int (*LoadGFXRessources)(__int16 resourcePackId)=(int (__cdecl *)(__int16 resourcePackId))0x409BD0;
EXPORT_ONCE int (*DrawRankIcon)(int dst, int src, int width)=(int (__cdecl *)(int dst, int src, int width))0x4254A0;
EXPORT_ONCE int (*Tactical_KillUnit)(int)=(int (__cdecl *)(int))0x40E450;
EXPORT_ONCE void (*LoadTacticalGame)(char *)=(void (__cdecl *)(char *))0x416E90;
EXPORT_ONCE void (*LoadGeographGame)(char *)=(void (__cdecl *)(char *))0x44B9B0;
                            
EXPORT_ONCE void (*SaveTacticalData)(char *)=(void (__cdecl *)(char *))0x416020;
EXPORT_ONCE int (*PerformReactionFire)()=(int (__cdecl *)())0x40FA20;
EXPORT_ONCE void (*ComputeVisibleAliens)(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)=(void (__cdecl *)(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance))0x42EA40;
EXPORT_ONCE int (*AdjustShotWithAccuracy)()=(int (__cdecl *)())0x40DAE0;
EXPORT_ONCE int (*DD_SurfaceUnlock)()=(int (__cdecl *)())0x45C860;
EXPORT_ONCE unsigned char * (*DD_SurfaceLock)()=(unsigned char * (__cdecl *)())0x45C800;
EXPORT_ONCE int (*DD_SurfaceFlip)()=(int (__cdecl *)())0x45C880;

EXPORT_ONCE short *language=(short *)0x4783AC;
EXPORT_ONCE int *carretPosition=(int *)0x4A3F6C;
EXPORT_ONCE unitref_dat **currentUnit_pUnitRef=(unitref_dat **)0x4A3E88;
EXPORT_ONCE unitref_dat **file_missdat_uniref_dat=(unitref_dat **)0x4A6B40;

EXPORT_ONCE short *unitIdx=(short *)0x4783B4;
EXPORT_ONCE short *tactical_mainState=(short *)0x4781DC;
EXPORT_ONCE short *geoscape_mainState=(short *)0x49B214;
EXPORT_ONCE short *zoomGeoGlobe=(short *)0x46F67C;

EXPORT_ONCE int *CurrentMidiPlaying=(int *)0x4758E8;
EXPORT_ONCE short *currentBaseIdx=(short *)0x49AAC8;
EXPORT_ONCE short *tac_debug=(short *)0x477BD2;
EXPORT_ONCE short *tac_debug_alienPuppies=(short *)0x46D1F2;
EXPORT_ONCE short *tac_currentTUReserveMode=(short *)0x478464;
EXPORT_ONCE short *difficultyLevel=(short *)0x49B85E;
EXPORT_ONCE short *geo_timeSpeed=(short *)0x49AAB4;

EXPORT_ONCE char *tac_misdata=(char *)0x4A3EA0;
EXPORT_ONCE unsigned char **locationList=(unsigned char **)0x49AAB0;
EXPORT_ONCE unsigned char **craftList=(unsigned char **)0x49AB18;

EXPORT_ONCE char **StringTable_geoscape=(char **)0x47A3A4;
EXPORT_ONCE char **StringTable_battlescape=(char **)0x49D660;
 
EXPORT_ONCE short *DrawText_leftBorder=(short *)0x4782AE;
EXPORT_ONCE short *DrawText_rightBorder=(short *)0x4782B0;
EXPORT_ONCE short *currentGFXPackage=(short *)0x4782A6;

EXPORT_ONCE short **smokeTabRessources=(short **)0x4ADE3C;
EXPORT_ONCE char **smokePCKRessources=(char **)0x4A3F7C;
EXPORT_ONCE char **BackBuffer=(char **)0x4ADE30;

EXPORT_ONCE char *IsDuringInitialUPSExplosion=(char *)0x477EB4;
                    
EXPORT_ONCE char *unitpos_dat=(char *)0x4A2C40;
EXPORT_ONCE unsigned char **file_geodata_obdata_dat=(unsigned char **)0x4A3F54;

EXPORT_ONCE short *currentWeapon_damageType=(short *)0x4783EA;

EXPORT_ONCE short *map_numTilesPerLevel=(short *)0x4A3134;
EXPORT_ONCE int **pMap=(int **)0x4A3144;
EXPORT_ONCE unsigned char **pSeeMap=(unsigned char **)0x4ADEE0;

EXPORT_ONCE unsigned char *pGeodata=(unsigned char *)0x4A6AE0;

EXPORT_ONCE unsigned char **pBaseList=(unsigned char **)0x49AAD8;

EXPORT_ONCE unsigned char *Tac_Show_LaunchRocket_Icon=(unsigned char *)0x4782B7;
EXPORT_ONCE unsigned char *Tac_numRocketWayPoints=(unsigned char *)0x478478;


EXPORT_ONCE short *Tac_RocketWayPoints=(short *)0x49DA00;
EXPORT_ONCE short **file_ufograph_cursor_tab=(short **)0x4A6A80;
EXPORT_ONCE char **file_ufograph_cursor_pck=(char **)0x4A5FB0;
EXPORT_ONCE int (*DrawPCKSprite)(__int16, __int16, int, int)=(int (__cdecl *)(__int16,__int16,int,int))0x430640;

EXPORT_ONCE short *mouse_num_click1=(short *)0x4A3F68;
EXPORT_ONCE short *mouse_num_click2=(short *)0x4A59E8;

EXPORT_ONCE short *mouse_xpos_click_2=(short *)0x4A3F64;
EXPORT_ONCE short *mouse_ypos_click_2=(short *)0x4A3F66;

EXPORT_ONCE short *mouseCursorId=(short *)0x4781D0;
EXPORT_ONCE int *mouse_buttons=(int *)0x46E3D8;

EXPORT_ONCE short *tac_currentTile_xpos=(short *)0x4781CC;
EXPORT_ONCE short *tac_currentTile_ypos=(short *)0x4781CA;

EXPORT_ONCE short *tac_xview=(short *)0x4781D4;
EXPORT_ONCE short *tac_yview=(short *)0x4781D2;
EXPORT_ONCE short *tac_zview=(short *)0x46B77E;


EXPORT_ONCE unsigned char **currentUnit_pUnitPos=(unsigned char **)0x4A5FC0;
EXPORT_ONCE void (*SetFiringPointOrigin)(unsigned char *)=(void (__cdecl *)(unsigned char *))0x40D8E0;

EXPORT_ONCE short *accuracy=(short *)0x478422;
EXPORT_ONCE short *WeaponMenu_NumEntries=(short *)0x4783CC;

typedef struct {
	short actionType;
	short accuracy;
	short TUusage;
	short weaponStrength;
	short damageType;
} menu_item;

EXPORT_ONCE menu_item *WeaponMenu_Items=(menu_item *)0x4A6AA0;
EXPORT_ONCE short *WeaponMenu_ClickedItem=(short *)0x478200;


EXPORT_ONCE short *currentWeapon_damage=(short *)0x4783E8;

EXPORT_ONCE void (*SetTacticalViewPos)(int ypos, int xpos, __int16 zpos)=(void (__cdecl *)(int ypos, int xpos, __int16 zpos))0x412060;

EXPORT_ONCE void (*DoDamageToShotTile)()=(void (__cdecl *)())0x40DC90;
EXPORT_ONCE void (*FixShotTile)()=(void (__cdecl *)())0x427090;
                            
EXPORT_ONCE short *Tactical_weaponHasHitSomeone=(short *)0x4A282A;
EXPORT_ONCE short *Tactical_weaponHasHitSomething=(short *)0x4A2830;

EXPORT_ONCE short *impactArmorSide=(short *)0x4A2838;
EXPORT_ONCE void (*Tactical_DoDamageToUnit)(__int16 impactSide, __int16 playAnimation)=(void (__cdecl *)(__int16 impactSide, __int16 playAnimation))0x40DEA0;

EXPORT_ONCE short *Tactical_StatusErrorMessage=(short *)0x4781E8;

EXPORT_ONCE int (*GetRelativePositioning)(int y1, int x1, int y2, int x2)=(int (__cdecl *)(int y1, int x1, int y2, int x2))0x421790;
EXPORT_ONCE void (*TryChangeUnitOrientation)(int pUnitPos, int orientation)=(void (__cdecl *)(int pUnitPos, int orientation))0x421830;


EXPORT_ONCE short *currentUnit_ypos=(short *)0x4781E0;
EXPORT_ONCE short *currentUnit_xpos=(short *)0x4781E2;
EXPORT_ONCE short *currentUnit_zpos=(short *)0x4781E4;
EXPORT_ONCE short *currentUnit_idx=(short *)0x4781E6;


EXPORT_ONCE int *mouse_ypos=(int *)0x46E3E0;
EXPORT_ONCE int *mouse_xpos=(int *)0x46E3DC;
                            

EXPORT_ONCE short *needsToUpdateTerrainLightSources=(short *)0x49DB10;
EXPORT_ONCE short *needsToUpdateSoldiersLightSources=(short *)0x4A2842;

EXPORT_ONCE void (*TacticalComputeTerrainLightSources)()=(void (__cdecl *)())0x418940;
EXPORT_ONCE void (*TacticalComputeSoldiersLightSources)()=(void (__cdecl *)())0x418780;

EXPORT_ONCE char **currentDamagedUnit_pUnitPos=(char **)0x4A285C;
EXPORT_ONCE void (*GenerateExplosion)(int xpos, int ypos, __int16 zpos, int strength, int, int, __int16)=(void (__cdecl *)(int xpos, int ypos, __int16 zpos, int strength, int, int, __int16))0x40B420;

#pragma pack(1)
typedef struct
{
	short active;
//	unsigned char *pObpos;
	obpos_dat *pObpos;
} prox_entry;

EXPORT_ONCE prox_entry *tac_prox_mine_list=(prox_entry *)0x478208;
//EXPORT_ONCE unsigned char *pObpos_dat=(unsigned char *)0x4A5FE0;
EXPORT_ONCE obpos_dat *pObpos_dat=(obpos_dat *)0x4A5FE0;

EXPORT_ONCE void (*ActAccordingToTacticalState)()=(void (__cdecl *)())0x41FE30;

EXPORT_ONCE void (*SetCurrentUnit)(int)=(void (__cdecl *)(int))0x4202A0;

//EXPORT_ONCE short *map_numTilesPerLevel=(short *)0x4A3134;
EXPORT_ONCE short *tac_mapZSize=(short *)0x4A5FB8;

EXPORT_ONCE void (*CreateButton)(int,int,int,int,int,char *)=(void (__cdecl *)(int,int,int,int,int,char *))0x450D00;
EXPORT_ONCE void (*WaitTillMouseButtonsAreReleased)()=(void (__cdecl *)())0x43D8A0;
EXPORT_ONCE int (*CheckForClickedButton)()=(int (__cdecl *)())0x450FF0;
EXPORT_ONCE short *ui_numButtons=(short *)0x478462;
EXPORT_ONCE short (*GetFreeObPosRef)()=(short (__cdecl *)())0x40EBD0;

EXPORT_ONCE void (*UpdateAirborneShipsPosition)()=(void (__cdecl *)())0x4576B0;
EXPORT_ONCE short *numAirborneShips=(short *)0x49AB2C;
EXPORT_ONCE short *numUfosInRetaliationMission=(short *)0x49B22A;
EXPORT_ONCE short *numHiddenAlienShips=(short *)0x49B8E4;
EXPORT_ONCE short *nextSpottedUFONumber=(short *)0x46F69C;

                               
EXPORT_ONCE int (*GetCountryFromPos)(__int16,__int16)=(int (__cdecl *)(__int16,__int16))0x459830;
EXPORT_ONCE int (*GetWorldZoneFromPos)(__int16,__int16)=(int (__cdecl *)(__int16,__int16))0x4597D0;
EXPORT_ONCE int (*IsPointOnWater)(unsigned short,unsigned short)=(int (__cdecl *)(unsigned short,unsigned short))0x458700;
//EXPORT_ONCE int (*IsPointOnWater)(int,int)=(int (__cdecl *)(int,int))0x458700;
EXPORT_ONCE void (*RotateGlobeToLocation)(__int16 locationIdx)=(void (__cdecl *)(__int16 locationIdx))0x459080;

EXPORT_ONCE unsigned char **file_geodata_world_dat=(unsigned char **)0x49B850;

EXPORT_ONCE void (*LoadGeographBackScreen)(short)=(void (__cdecl *)(short))0x43F250;
EXPORT_ONCE void (*LoadGeodataBackPalette)(short)=(void (__cdecl *)(short))0x45AFC0;

EXPORT_ONCE int (*DrawDottedLine)(int col, int, char)=(int (__cdecl *)(int col, int, char))0x043F310;

EXPORT_ONCE short *Dialog_ClickedItem=(short *)0x49B224;

                               
EXPORT_ONCE short (*GeoPerformDailyActions)()=(short (__cdecl *)())0x441A40;

EXPORT_ONCE int *IsTacticalMode=(int *)0x478630;
EXPORT_ONCE int *HasKeyBeenPressed=(int *)0x478620;
                                
EXPORT_ONCE void (*DI_AcquireState)()=(void (__cdecl *)())0x45E450;
EXPORT_ONCE unsigned char *DI_KeyStateBuffer=(unsigned char *)0x478920;
EXPORT_ONCE void (*DI_GetPressedKey)()=(void (__cdecl *)())0x45E540;


EXPORT_ONCE void (*StatusBarClicked)(short)=(void (__cdecl *)(short icon))0x412940;
EXPORT_ONCE void (*CheckIfClickedOnStatusBar)()=(void (__cdecl *)())0x4127F0;

EXPORT_ONCE short *inventory_draggedItem_obPosIdx=(short *)0x4783BC;
EXPORT_ONCE short *inventory_draggedItem_objectType=(short *)0x46C994;

EXPORT_ONCE int (*GetDistance)(int x1, int y1, int x2, int y2)=(int (__cdecl *)(int x1, int y1, int x2, int y2))0x418740;

EXPORT_ONCE void (*ShowSoldierStats)(char *)=(void (__cdecl *)(char *pUnitPos))0x40A400;

EXPORT_ONCE void (*CreateAlienBase)(int zone, char race)=(void (__cdecl *)(int zone, char race))0x432700;
EXPORT_ONCE void (*CreateXComBase)(__int16 isInitialBase)=(void (__cdecl *)(__int16 isInitialBase))0x437EA0;


EXPORT_ONCE void (*AddDialogButton)(__int16 xPos, __int16 type)=(void (__cdecl *)(__int16 xPos, __int16 type))0x43E0A0;
EXPORT_ONCE unsigned short *DlgNumButtons=(unsigned short *)0x49AADC;
EXPORT_ONCE unsigned short *DlgUpperLowerButtonPressed=(unsigned short *)0x49AB1C;
EXPORT_ONCE unsigned short *DlgDialog_ClickedItem=(unsigned short *)0x49B224;
EXPORT_ONCE unsigned short *DlgNumItems=(unsigned short *)0x49B854;
EXPORT_ONCE unsigned short *DlgItemIdList=(unsigned short *)0x49A860;
EXPORT_ONCE unsigned char **pSoldierDat=(unsigned char **)0x49B954;

EXPORT_ONCE int (*CheckHasLineOfFire)(__int16 ypos, __int16 xpos, __int16 zpos)=(int (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos))0x42AD80;
EXPORT_ONCE int (*CheckIfClickedOnUnit)(__int16 ypos, __int16 xpos, __int16 zpos)=(int (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos))0x4201F0;

EXPORT_ONCE unsigned char *firstBaseTemplate=(unsigned char *)0x46F1C8;

EXPORT_ONCE int (*GetSoldierScoreForPromotion)(__int16 soliderIdx)=(int (__cdecl *)(__int16 soliderIdx))0x449500;


//init some variables related to moving/opening doors
EXPORT_ONCE int (*sub_422B60)(__int16 ypos, __int16 xpos, __int16 zpos, int, int, int orientation, int movementType)=(int (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos, int, int, int orientation, int movementType))0x422B60;

EXPORT_ONCE	void (*OpenFacingDoor)(int doorType)=(void (__cdecl *)(int doorType))0x421140;
EXPORT_ONCE unsigned short *MustGoThroughDoor=(unsigned short *)0x478284;

EXPORT_ONCE	void (*UpdateCurrentlyFacedTile)()=(void (__cdecl *)(void))0x41DC50;
EXPORT_ONCE unsigned char *facingTile_ypos=(unsigned char *)0x4782AB;
EXPORT_ONCE unsigned char *facingTile_xpos=(unsigned char *)0x4782AC;
EXPORT_ONCE unsigned char *facingTile_isValid=(unsigned char *)0x4782AD;

EXPORT_ONCE	void (*UpdateSeeMapAndVisibleEnemies)()=(void (__cdecl *)(void))0x42DD50;
EXPORT_ONCE	void (*DrawMouseCursor)()=(void (__cdecl *)(void))0x42FCC0;

EXPORT_ONCE	void (*myfflush)(FILE *)=(void (__cdecl *)(FILE *))0x4600E7;

EXPORT_ONCE	void (*GeoHandleLeftClick)()=(void (__cdecl *)(void))0x451220;

#pragma pack(1)
typedef struct
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
} palette_entry;

EXPORT_ONCE palette_entry *palette=(palette_entry *)0x49C740;

EXPORT_ONCE	void (*Tactical_EquipTeamDisplay)()=(void (__cdecl *)(void))0x41A2C0;

EXPORT_ONCE unsigned char *tac_ambient_light=(unsigned char *)0x4A2832;

EXPORT_ONCE	unsigned char (*sub_41CB30)(__int16 unknow, __int16 uniposIdx, __int16 objType)=(unsigned char (__cdecl *)(__int16, __int16 uniposIdx, __int16 objType))0x41CB30;

EXPORT_ONCE	void (*InitNewGeoGame)()=(void (__cdecl *)(void))0x43AC40;

EXPORT_ONCE	void (*SaveGeoGameData)(char *)=(void (__cdecl *)(char *slot))0x44ABC0;


EXPORT_ONCE	void *(*LoadResourceFile)(char *)=(void *(__cdecl *)(char *lpFileName))0x43B470;

EXPORT_ONCE unsigned char *isDuringReactionFire=(unsigned char *)0x4783E4;


EXPORT_ONCE	void (*TacticalDrawPanicMessage)(int unitIdx)=(void (__cdecl *)(int unitIdx))0x41FAD0;

EXPORT_ONCE unsigned char *tac_playing_side=(unsigned char *)0x4781C8;

EXPORT_ONCE unsigned short *geo_num_rearming_crafts=(unsigned short *)0x49AA60;

EXPORT_ONCE	void (*ShowSoldierStat)(int soldierIdx, __int16 baseLocIdx)=(void (__cdecl *)(int soldierIdx, __int16 baseLocIdx))0x43F780;

EXPORT_ONCE int* money = (int*)0x49B110;
EXPORT_ONCE short* geo_currentHour = (short*)0x49AABC;
EXPORT_ONCE short* geo_currentMinute = (short*)0x49AAA4;
EXPORT_ONCE short* geo_currentSecond = (short*)0x49B8E2;
EXPORT_ONCE short* geo_currentDayOfTheWeek = (short*)0x49AA9C;
EXPORT_ONCE short* geo_currentDay = (short*)0x49B226;
EXPORT_ONCE short* geo_currentMonth = (short*)0x49B1B8;
EXPORT_ONCE short* geo_currentYear = (short*)0x49A842;
EXPORT_ONCE void* file_geograph_geobord_scr = (void*)0x49B910;
EXPORT_ONCE char** StringsTable_geoscape = (char**)0x47A3A8;
EXPORT_ONCE short* month_names_index = (short*)0x4738E8;
EXPORT_ONCE char** languageStuff_geoscape = (char**)0x47A3A0;
EXPORT_ONCE char* DrawNumber2_useThousandSeparator = (char*)0x49AABA;
EXPORT_ONCE char* ProductDat = (char*)0x4703C8;
EXPORT_ONCE char** BProdDat = (char**)0x49AAD0;
EXPORT_ONCE char* PurchaseDat = (char*)0x470750;
EXPORT_ONCE char** BaseDat = (char**)0x49AAD8;

#pragma pack(push,1)
typedef struct
{
	unsigned char ypos;
	unsigned char xpos;
	unsigned char zpos;
	unsigned char unk0;
	unsigned int unitRefPtr;
	unsigned char detected;
	unsigned char owner;
	unsigned char flags;
	unsigned char unk1;
	unsigned char unk2;
	unsigned char unk3;
}
unitpos_datx;
#pragma pack(pop)

EXPORT_ONCE unitpos_datx *file_missdat_unipos_dat=(unitpos_datx *)0x4A2C40;

//Functions
EXPORT_ONCE int (*BlitToBackBuffer)(int src) = (int (__cdecl*)(int src))0x43F2F0;

EXPORT_ONCE unsigned char *(*GetTileAt)(__int16 xpos, __int16 ypos, __int16 zpos) = (unsigned char *(__cdecl*)(__int16 xpos, __int16 ypos, __int16 zpos))0x417B80;

EXPORT_ONCE short* clickedUnit_unitpos = (short*)0x4A3154; //global that stores the position of the unit clicked
EXPORT_ONCE int* clickedUnit_idx = (int*)0x4783D8; //global that stores the index of the unit clicked
EXPORT_ONCE unitpos_datx* UnitposDat = (unitpos_datx*)0x4A2C40;
